---
title: ExtendableMessageEvent.lastEventId
slug: Web/API/ExtendableMessageEvent/lastEventId
tags:
  - API
  - Experimental
  - ExtendableMessageEvent
  - Property
  - Reference
  - Service Workers
  - lastEventID
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <strong><code>lastEventID</code></strong> read-only property of the {{domxref("ExtendableMessageEvent")}} interface represents, in <a href="/en-US/docs/Web/API/Server-sent_events/Using_server-sent_events">server-sent events</a>, the last event ID of the event source. This is an empty string.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>myLastEventId</em> = <em>extendableMessageEvent</em>.lastEventId;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}}.</p>

<h2 id="Examples">Examples</h2>

<p>When the following code is used inside a service worker to respond to a push messages by sending the data received via {{domxref("PushMessageData")}} to the main context via a <a href="/en-US/docs/Web/API/Channel_Messaging_API">channel message</a>, the event object of <code>onmessage</code> will be a <code>ExtendableMessageEvent</code>.</p>

<pre class="brush: js notranslate">var port;

self.addEventListener('push', function(e) {
  var obj = e.data.json();

  if(obj.action === 'subscribe' || obj.action === 'unsubscribe') {
    port.postMessage(obj);
  } else if(obj.action === 'init' || obj.action === 'chatMsg') {
    port.postMessage(obj);
  }
});

self.onmessage = function(e) {
  console.log(e.lastEventId);
  port = e.ports[0];
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#dom-extendablemessageevent-lasteventid', 'ExtendableMessageEvent.lastEventId')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ExtendableMessageEvent.lastEventId")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a class="external external-icon" href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a class="external external-icon" href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API">Channel Messaging</a></li>
</ul>
